#ifndef CHART_H
#define CHART_H

#include <qstring.h>
#include <qlabel.h>

#include <qmainwindow.h>
#include <qwidget.h>

#include <qchart.h>
#include <qchartview.h>
#include <QtCharts/QAbstractAxis>
#include <QtCharts/QSplineSeries>
#include <QtCharts/QValueAxis>
#include <QtCore/QRandomGenerator>
#include <QtCore/QTimer>

#include "general.h"


#if (QT_VERSION < QT_VERSION_CHECK(6, 0, 0))
using namespace QtCharts;
#endif

class Chart;

class QLineChart : public QWidget
{
    Q_OBJECT
public:

    struct T_CharData
    {
        qreal qrOldMaxValue;
        qreal qrOldMinValue;
        qreal qrMaxValue;
        qreal qrMinValue;

        QList<QPointF> dataList;

        void init()
        {
            qrOldMaxValue = qrealMIN;
            qrOldMinValue = qrealMAX;
            qrMaxValue = qrealMAX;
            qrMinValue = qrealMIN;

            dataList.clear();
        }
    };

    QLineChart ( QWidget *parent );
    ~QLineChart();

    
    void setMinMaxValue( QValueAxis *qvaValue,  QPointF *qpfValue, struct T_CharData &charData );

    QChart qcChart;
    QChartView *qcvView; 
    QLineSeries qlsSeries;
    QValueAxis qvaAxisX;
    QValueAxis qvaAxisY;

    QLabel *qlLegend;

    struct T_CharData charData;

    qreal maxAxisX = 10;
    qreal minAxisX = 0;
    qreal stepAxisX = 0.1;

public:
    void setValue( QString qsValue );
    void addValue( qreal qrValue );
    
protected:
    void resizeEvent( QResizeEvent *qreEvent ) override;

private:
    void updateLegend();
    void updateSeries( QAbstractSeries *series );
};


class testChart : public QWidget
{
   Q_OBJECT
public:
    testChart();
    ~testChart();
    
    QLineChart *qclChart;
    QLineChart *qclChart2;

    QWidget *qwChart;
    QWidget *qwChart2;
    QFrame *qfChart;
    QFrame *qfChart2;

private:

    void timerEvent( QTimerEvent * ) override;

    int idTimer;

    qreal stepY = 0.1;

    qreal posY;    
};

#endif
