/***************************************************************************
                          lmsensorswidget.h  -  description
                             -------------------
    begin                : Mon Aug 6 2001
    Copyright	Giuseppe Della Bianca<giusdbg@gmail.com>

    original author	 : Miguel Novas
    email                : michaell@teleline.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LMSENSORSWIDGET_H
#define LMSENSORSWIDGET_H

#include <qwidget.h>
#include <qpixmap.h>

#include "ksensorssetting.h"

#include "sensordevsgroups.h"
#include "sensorpanel.h"
#include "syssensorslist.h"

/**
  *@original author Miguel Novas
  */

class InfoPanels;

class LMSensorsWidget : public QWidget, public ksensorsSetting
{
   Q_OBJECT
public:

	LMSensorsWidget(sensorDevsGroups *lsensors,QWidget *parent = nullptr, const QString &name = QString() );
	~LMSensorsWidget();

    void updateWidget( const QString &name, bool withChange );
        
    void saveGeometry();
  
/* public:
  QTimer qtResize;
  
public Q_SLOTS:    
  void resizeDone();
    
protected:
  bool event(QEvent *event) override; */
  
  
protected Q_SLOTS:

Q_SIGNALS:

   void rightMouseClicked(QMouseEvent *);

private:

  sensorDevsGroups  *sensors;
  SYSSensorsList *sysPanels;

  QWidget    *childDraging;
  int         panelsSize;
  QPoint			origMousePt;

  bool windowsSolid;
  QPixmap qpmBackGround;
  QPalette qpLMSensorsWidget;

  void loadPalette(Panel *panel = nullptr);
//  void setBackgroundPixmap ( const QPixmap &qpmBackGround );
  void loadDisplayConfig(Panel *display);
  void saveDisplayConfig(Panel *display);
  void mouseReleaseEvent ( QMouseEvent *m ) override;
  void mouseMoveEvent ( QMouseEvent *m ) override;

  void createSensorPanels();
  void findUnusedPosition(int *px,int *py);
  void startDragChild(QMouseEvent *m, QWidget *w);
  void endDragChild();
  void updatePanels();
  void loadGeneralOptions( bool enabForce );

private Q_SLOTS:

  void childEvent(QChildEvent *) override;
  void childEventReceived(QEvent *);

};

#endif
